//+------------------------------------------------------------------+

/////////QQE HISTO ALARM
///////////////////
//|   Qualitative Quantitative Estimation Indicator for Metatrader 4 |
//|                                    Copyright  2006Roman Ignatov |
//|                                   mailto:roman.ignatov@gmail.com |
//+------------------------------------------------------------------+
//mod alerts
///////MODIFIED TO DO HISTOGRAM BY SOHOCOOL 09/2012
#property copyright "Copyright  200 Roman Ignatov"
#property link      "mailto:roman.ignatov@gmail.com"

#property indicator_separate_window

#property indicator_buffers 4



#property indicator_color1 LawnGreen
#property indicator_style1 STYLE_SOLID
#property indicator_width1 5

#property indicator_color2 Tomato
#property indicator_style2 STYLE_SOLID
#property indicator_width2 5

#property indicator_color3 Blue
#property indicator_style3 STYLE_SOLID
#property indicator_width3 3

#property indicator_color4 White
#property indicator_style4 STYLE_DOT
#property indicator_width4 2


#property indicator_maximum 100
#property indicator_minimum 0


extern int SF = 5; // original 5
extern int RSI_Period = 7; // original 14
extern double DARFACTOR = 4.236; //original 4.236

extern bool   BoxAlertON       = true;
extern bool   SoundAlertON     = true;
extern bool   EmailAlertON     = false;
extern int    alertDelayBars       = 0;           
extern string soundfile            = "stops.wav"; //ok.wav/alert.wav/short.wav
double alertboxTag,alertsoundTag,alertmailTag; 

int Wilders_Period;
int StartBar;

double TrLevelSlow[];
double AtrRsi[];
double MaAtrRsi[];
double Rsi[];
double RsiMa[];
double trend[];
double trend1[];

int init()
{
    Wilders_Period = RSI_Period * 2 - 1;
    if (Wilders_Period < SF)
        StartBar = SF;
    else
        StartBar = Wilders_Period;
        
    IndicatorBuffers(8);
    SetIndexBuffer(2, RsiMa);
    SetIndexStyle(2, DRAW_LINE);
    SetIndexLabel(2, "Value 1");
    SetIndexDrawBegin(2, StartBar);
    SetIndexStyle(3, DRAW_LINE);
    SetIndexBuffer(3, TrLevelSlow);
    SetIndexLabel(3, "Value 2");
    SetIndexDrawBegin(3, StartBar);
    SetIndexBuffer(4, AtrRsi);
    SetIndexBuffer(5, MaAtrRsi);
    SetIndexBuffer(6, Rsi);
    SetIndexBuffer(7, trend);
    SetIndexStyle(0, DRAW_HISTOGRAM);
    SetIndexBuffer(0, trend);
    SetIndexLabel(0, "Value 3");
    SetIndexDrawBegin(0, StartBar);
    SetIndexBuffer(1, trend1);
    SetIndexStyle(1, DRAW_HISTOGRAM);
    SetIndexBuffer(1, trend1);
    SetIndexLabel(1, "Value 4");
    SetIndexDrawBegin(1, StartBar);
    
    IndicatorShortName(StringConcatenate("QQE(", SF, ")"));
    return(0);
}


int start()
{
    int counted, i;
    double rsi0, rsi1, dar, tr, dv;
    
    if(Bars <= StartBar)
        return (0);

    counted = IndicatorCounted();
    if(counted < 1)
        for(i = Bars - StartBar; i < Bars; i++)
        {
            TrLevelSlow[i] = 0.0;
            AtrRsi[i] = 0.0;
            MaAtrRsi[i] = 0.0;
            Rsi[i] = 0.0;
            RsiMa[i] = 0.0;
        }
    
    counted = Bars - counted - 1;
        
    for (i = counted; i >= 0; i--)
        Rsi[i] = iRSI(NULL, 0, RSI_Period, PRICE_CLOSE, i);

    for (i = counted; i >= 0; i--)
    {
        RsiMa[i] = iMAOnArray(Rsi, 0, SF, 0, MODE_EMA, i);
        AtrRsi[i] = MathAbs(RsiMa[i + 1] - RsiMa[i]);
    }

    for (i = counted; i >= 0; i--)
        MaAtrRsi[i] = iMAOnArray(AtrRsi, 0, Wilders_Period, 0, MODE_EMA, i);

    i = counted + 1;
    tr = TrLevelSlow[i];
    rsi1 = iMAOnArray(Rsi, 0, SF, 0, MODE_EMA, i);
    while (i > 0)
    {
        i--;
        rsi0 = iMAOnArray(Rsi, 0, SF, 0, MODE_EMA, i);
        dar = iMAOnArray(MaAtrRsi, 0, Wilders_Period, 0, MODE_EMA, i) * DARFACTOR;

        dv = tr;
        if (rsi0 < tr)
        {
            tr = rsi0 + dar;
            if (rsi1 < dv)
                if (tr > dv)
                    tr = dv;
        }
        else if (rsi0 > tr)
        {
            tr = rsi0 - dar;
            if (rsi1 > dv)
                if (tr < dv)
                    tr = dv;
        }
        TrLevelSlow[i] = tr;
        rsi1 = rsi0;
        
         //trend[i] = trend[i+1];
     if (RsiMa[i]>TrLevelSlow[i])
     { trend[i] = 100;
     trend1[i]=0;}
     if (RsiMa[i]<TrLevelSlow[i]) 
     {trend1[i] =100;
     trend[i]=0;}



         string message= Symbol()+" M"+Period()+" "+DoubleToStr(Close[0],4); // Bid    +DoubleToStr(Close[0],4)   

         int b=i+alertDelayBars;

         if(RsiMa[b]> TrLevelSlow[b] && RsiMa[b+1]< TrLevelSlow[b+1])
           {
               if (BoxAlertON && alertboxTag!=Time[b]) 
                     {  Alert("QQE Cross: Trend going Up on ",message); alertboxTag = Time[b];
                     }
               
               if (EmailAlertON && alertmailTag!=Time[b])
                     {  SendMail("QQEA","QQECross: Trend going Up on "+message); alertmailTag = Time[b];
                     }
               if (SoundAlertON && alertsoundTag!=Time[b])
                     {  PlaySound (soundfile); alertsoundTag = Time[b];
                     }
            }   
 

         if(RsiMa[b]< TrLevelSlow[b] && RsiMa[b+1]> TrLevelSlow[b+1])
            { 
               if (BoxAlertON && alertboxTag!=Time[b]) 
                     {  Alert("QQE Cross: Trend going Down on ",message); alertboxTag = Time[b];
                     }
               
               if (EmailAlertON && alertmailTag!=Time[b])
                     {  SendMail("QQEA","QQECross: Trend going Down on "+message); alertmailTag = Time[b];
                     }
               if (SoundAlertON && alertsoundTag!=Time[b])
                     {  PlaySound (soundfile); alertsoundTag = Time[b];
                     }
        } 


    }
    
    return(0);
}

